`timescale 1ns / 1ps
//@Fs{wHw@HwȂRNO@HwII@QlvWFNg
//@쐬F@2013/6/3@ҁFBasys2+ISEp
//  CF@2017/4/27 ҁFBasys3{VivadoɑΉ
//
//@47ZOgLED\W[
//
// W[FDisplay7SEG
//
// ́F
// @CLK = NbN(100MHz)
//  RESET = Zbg(1̎Zbgj
//  [3:0] DIGIT_0 = \l(0ځj
//  [3:0] DIGIT_1 = \l(1ځj
//  [3:0] DIGIT_2 = \l(2ځj
//  [3:0] DIGIT_3 = \l(3ځj
// óF
//  [11:0] SEG = 47ZOgLED̕\pM

module Display7SEG(
	input CLK,
	input RESET,
	input [3:0] DIGIT_0,
	input [3:0] DIGIT_1,
	input [3:0] DIGIT_2,
	input [3:0] DIGIT_3,
	output [11:0] SEG
    );

	reg [8:0] div_counter;
	reg [1:0] counter;
	reg [3:0] sel;
	reg [3:0] ff;
	reg [7:0] temp_seg;

	always @(posedge CLK)
	begin 
		if(RESET)
			div_counter <= 0;
		else 
			div_counter <= div_counter + 1;
	end

	always @(posedge CLK)
	begin 
		if(RESET)
			counter <= 0;
		else 
			if(div_counter==9'b111111111)
				counter <= counter + 1;
	end


	always @(posedge CLK)
	begin 
		if(RESET)
			ff <= 0;
		else 
			case(counter) 
				2'b00: ff <= DIGIT_3;
				2'b01: ff <= DIGIT_2;
				2'b10: ff <= DIGIT_1;
				2'b11: ff <= DIGIT_0;
			endcase
	end

	always @(posedge CLK)
	begin 
		if(RESET)
			sel <= 0;
		else 
			case(counter) 
				2'b00: sel <= 4'b1110;
				2'b01: sel <= 4'b1101;
				2'b10: sel <= 4'b1011;
				2'b11: sel <= 4'b0111;
			endcase
	end

	always @(posedge CLK)
	begin
		if(RESET)
			temp_seg <= 0;
		else
			case(ff)
				4'b0000:temp_seg <= 8'b1_1000000; // 0
				4'b0001:temp_seg <= 8'b1_1111001; // 1
				4'b0010:temp_seg <= 8'b1_0100100; // 2
				4'b0011:temp_seg <= 8'b1_0110000; // 3
				4'b0100:temp_seg <= 8'b1_0011001; // 4
				4'b0101:temp_seg <= 8'b1_0010010; // 5
				4'b0110:temp_seg <= 8'b1_0000010; // 6
				4'b0111:temp_seg <= 8'b1_1011000; // 7
				4'b1000:temp_seg <= 8'b1_0000000; // 8
				4'b1001:temp_seg <= 8'b1_0010000; // 9
				4'b1010:temp_seg <= 8'b1_0001000; // A
				4'b1011:temp_seg <= 8'b1_0000011; // b
				4'b1100:temp_seg <= 8'b1_1000110; // c
				4'b1101:temp_seg <= 8'b1_0100001; // d
				4'b1110:temp_seg <= 8'b1_0000110; // E
				4'b1111:temp_seg <= 8'b1_0001110; // F
			endcase
	end

	assign SEG = {sel, temp_seg};

endmodule
